Capitalist = LibStub("AceAddon-3.0"):NewAddon("Capitalist", "AceEvent-3.0", "AceConsole-3.0")
Capitalist.Locale = {}
local L = Capitalist.Locale

-- REVIEW: Probably should make a DB file for these helpers

function Capitalist:GetProfile()
	return self.db.profile
end

function Capitalist:EnsureProfile()
	if (not self.db.profile) then
		self.db.profile = {}
	end
end

function Capitalist:UseProfile()
	self:EnsureProfile()
	return self:GetProfile()
end


function Capitalist:GetProfile_Realm_Faction(r, f)
	local oProfile = self:GetProfile()
	if (oProfile) then
		return oProfile[r .. "-" .. f]
	end
	return nil
end

function Capitalist:EnsureProfile_Realm_Faction(r, f)
    local oProfile = self:UseProfile()
	if (not oProfile[r .. "-" .. f]) then
		oProfile[r .. "-" .. f] = {}
	end
end

function Capitalist:UseProfile_Realm_Faction(r, f)
    self:EnsureProfile_Realm_Faction(r, f)
	return self:GetProfile()[r .. "-" .. f]
end


function Capitalist:GetProfile_Realm_Faction_Character(r, f, c)
	local oRealm = self:GetProfile_Realm_Faction(r, f)
	if (oRealm) then
		return oRealm[c]
	end
	return nil
end

function Capitalist:EnsureProfile_Realm_Faction_Character(r, f, c)
    local oRealm = self:UseProfile_Realm_Faction(r, f)
	if (not oRealm[c]) then
		oRealm[c] = {}
	end
end

function Capitalist:UseProfile_Realm_Faction_Character(r, f, c)
    self:EnsureProfile_Realm_Faction_Character(r, f, c)
	return self:GetProfile_Realm_Faction(r, f)[c]
end


function Capitalist:GetProfile_Realm_Faction_Character_Profession(r, f, c, p)
	local oCharacter = self:GetProfile_Realm_Faction_Character(r, f, c)
	if (oCharacter) then
		return oCharacter[p]
	end
	return nil
end

function Capitalist:EnsureProfile_Realm_Faction_Character_Profession(r, f, c, p)
    local oCharacter = self:UseProfile_Realm_Faction_Character(r, f, c)
	if (not oCharacter[p]) then
		oCharacter[p] = {}
	end
end

function Capitalist:UseProfile_Realm_Faction_Character_Profession(r, f, c, p)
    self:EnsureProfile_Realm_Faction_Character_Profession(r, f, c, p)
	return self:GetProfile_Realm_Faction_Character(r, f, c)[p]
end


function Capitalist:GetProfile_Realm_Faction_Character_Profession_Skill(r, f, c, p, s)
	local oProfession = self:GetProfile_Realm_Faction_Character_Profession(r, f, c, p)
	if (oProfession) then
		return oProfession[s]
	end
	return nil
end

function Capitalist:EnsureProfile_Realm_Faction_Character_Profession_Skill(r, f, c, p, s)
    local oProfession = self:UseProfile_Realm_Faction_Character_Profession(r, f, c, p)
	if (not oProfession[s]) then
		oProfession[s] = {}
	end
end

function Capitalist:UseProfile_Realm_Faction_Character_Profession_Skill(r, f, c, p, s)
    self:EnsureProfile_Realm_Faction_Character_Profession_Skill(r, f, c, p, s)
	return self:GetProfile_Realm_Faction_Character_Skill(r, f, c, p)[s]
end
